<template>
  <div ref="foo" w-screen h-screen flex="~ col" items-center justify-start bg="black opacity-30" p="x-4 y-12 lg:y-18"
    @click.self="close" @key-press.esc="close">
    <div w-full max-w-xl flex="~ col" items-center justify-center bg-white p="6" border="2 rounded-lg" gap-4>
      <!-- transition="~ all" duration-300 ease-in-out origin-top -->
      <h1 text="xl" font-semibold>⬢&nbsp;&nbsp;Bygonz {{ show?.block && "Block" }}</h1>

      <BlockDetails v-if="show?.block" :key="show.block.uuid" v-bind="show.block" />

      <div v-else flex="~" items-center gap-4 p-4>
        <button p="x-4 y-2" border="2 rounded-lg" bg-dark text-white font-semibold
          @click="emitter.emit('bygonzLoad'); close()">
          bygonzLoad()</button>
        <button p="x-4 y-2" border="2 rounded-lg" bg-dark text-white font-semibold
          @click="emitter.emit('bygonzReset')">Reset
          DB</button>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { computed, ref } from 'vue'
// import 'uno.css'
import '@unocss/reset/tailwind.css'
import { Logger } from 'logger'
import { emitter } from './ui-utils'
import BlockDetails from './components/BlockDetails.vue'

import { $ref } from 'vue/macros'
const { ERROR, WARN, LOG, DEBUG, VERBOSE } = Logger.setup(Logger.DEBUG, { prefix: '[UI]', performanceEnabled: true }) // eslint-disable-line @typescript-eslint/no-unused-vars
type showArgs = { block: any, publicationHash: string }

const show = ref<null | showArgs>(null)

const close = () => {
  logseq.hideMainUI()
  show.value = null
}


emitter.on('open', (args: any) => {
  DEBUG("open ", args)
  if (args.block) {
    show.value = args as showArgs
  }
})

// const shareUrl = computed(() => {
//     DEBUG('button share URL?', show)
//     if (show.value?.block && show.value.publicationHash) {
//         const bygonzShareURL = `logseq://bygonz/open?pub=${show.value.publicationHash}&block=${show.value.block}`
//         DEBUG('button share URL:', bygonzShareURL)
//         return bygonzShareURL
//     }
// })

</script>

<style>
body {
  margin: 0;
  padding: 0;
}
</style>
